﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Collections;

namespace WindowsFormsApplication52
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            UltraGridLayout layout = e.Layout;
            UltraGridBand band = layout.Bands[0];
            UltraGridOverride ov = layout.Override;

            layout.ViewStyleBand = ViewStyleBand.OutlookGroupBy;

            UltraGridColumn column1 = band.Columns["Column 1"];
            UltraGridColumn column2 = band.Columns["Column 2"];
            UltraGridColumn column3 = band.Columns["Column 3"];

            // Group by Column 1. 
            band.SortedColumns.Add("Column 1", false, true);

            // Use a GroupByEvaluator to merge using the combined values from Column 1 and Column 2. 
            column1.GroupByEvaluator = new MyGroupByEvaluator();

            // Add a Summary of Column 3 so it shows up in the GroupByRow. 
            band.Summaries.Add(SummaryType.Sum, column3);
            ov.GroupBySummaryDisplayStyle = GroupBySummaryDisplayStyle.SummaryCells;
        }
    }

    internal class MyGroupByEvaluator : IGroupByEvaluator
    {


        #region IGroupByEvaluator Members

        bool IGroupByEvaluator.DoesGroupContainRow(UltraGridGroupByRow groupByRow, UltraGridRow row)
        {
            return groupByRow.Value.ToString() == this.GetCombinedText(row);
        }

        object IGroupByEvaluator.GetGroupByValue(UltraGridGroupByRow groupByRow, UltraGridRow row)
        {
            return GetCombinedText(row);
        }

        #endregion

        private string GetCombinedText(UltraGridRow row)
        {
            return row.Cells["Column 1"].Text + " " + row.Cells["Column 2"].Text;
        }
    }
}
